from cpl_query.extension import List

from bot_data.model.auto_role import AutoRole
from bot_graphql.abc.filter_abc import FilterABC


class AutoRoleFilter(FilterABC):
    def __init__(self):
        FilterABC.__init__(self)

        self._id = None
        self._channel_id = None
        self._message_id = None

    def from_dict(self, values: dict):
        if "id" in values:
            self._id = values["id"]

        if "channel_id" in values:
            self._channel_id = values["channel_id"]

        if "message_id" in values:
            self._message_id = values["message_id"]

    def filter(self, query: List[AutoRole]) -> List[AutoRole]:
        if self._id is not None:
            query = query.where(lambda x: x.id == self._id)

        if self._channel_id is not None:
            query = query.where(lambda x: x.discord_channel_id == self._channel_id)

        if self._message_id is not None:
            query = query.where(lambda x: x.discord_message_id == self._message_id)

        # if self._server_id is not None:
        #     query = query.where(lambda x: x.server.server_id == self._server_id)

        return query
